routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\PagesController;
use App\Http\Controllers\PostController;
use App\Http\Controllers\BlogController;
use App\Http\Controllers\Auth\LoginController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\TagController;
use App\Http\Controllers\CommentsController;
use App\Http\Controllers\AjaxController;





/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Route::group(['middleware' => ['web']], function(){

Route::get('blog/{slug}', [BlogController::class,'getSingle'])->name('blog.single')->where('slug', '[\w\d\-\_]+');
Route::get('blog', [BlogController::class,'getIndex'])->name('blog.index');
Route::get('contact', [PagesController::class,'getContact']);
Route::get('about', [PagesController::class,'getAbout']);
Route::get('/', [PagesController::class,'getIndex']);
Route::resource('posts', PostController::class);
Route::post('search', [PostController::class,'search'])->name('search');

//comments routes
Route::post('comments/{post_id}', [CommentsController::class,'store'])->name('comments.store');
Route::get('comments/{id}/edit', [CommentsController::class,'edit'])->name('comments.edit');
Route::put('comments/{id}', [CommentsController::class,'update'])->name('comments.update');
Route::delete('comments/{id}', [CommentsController::class,'destroy'])->name('comments.destroy');
Route::get('comments/{id}/delete', [CommentsController::class,'delete'])->name('comments.delete');




//categories routes
Route::resource('categories', CategoryController::class)->except(['create']);


//tags routes
Route::resource('tags', TagController::class)->except(['create']);

});

Auth::routes();
Route::get('logout', [LoginController::class,'logout'])->name('logout');
Route::get('auth/login', [HomeController::class,'getLogin']);

##ajax comment
Route::get('display_commentajax/{slug}', [CommentsController::class,'display_commentajax'])->name('display_commentajax');
Route::post('store_comments', [CommentsController::class,'store_comments'])->name('store_comments');


## ajax test
Route::get('ajax_test', [AjaxController::class,'ajax_test'])->name('ajax_test');
Route::post('store_user', [AjaxController::class,'store_user'])->name('store_user');
Route::get('display_user', [AjaxController::class,'display_user'])->name('display_user');

app/Models/Tag.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use App\Models\Post_Tagging;


class Tag extends Model
{
    use HasFactory;

    protected $table ='posts_tags';

    public function posts_count($id){
      $count = 0;

      $count = Post_Tagging::where('tag_id', $id)->count();

      return $count;

    }

}

app/Http/Controllers/TagController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Tag;
use App\Models\Post_Tagging;
use App\Models\Post;

use Session;



class TagController extends Controller
{

    public function __construct(){
      $this->middleware('auth');
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $tags = Tag::all();

        return view('tags.index')->with(['tags' => $tags]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
     public function store(Request $request)
         {
             $this->validate($request, array('name' => 'required|max:255'));
             $tag = new Tag;
             $tag->name = $request->name;
             $tag->save();

             Session::flash('success', 'New Tag was successfully created!');

             return redirect()->route('tags.index');
         }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $tag = Tag::find($id);
        $tag_count = $tag->posts_count($id);
        $tagging_postid = Post_Tagging::where('tag_id',$id)->pluck('post_id');

        $postdata = Post::whereIn('id', $tagging_postid)->get();

        foreach ($postdata as $key => $value) {
          $tagfrompost = Post_Tagging::where('post_id', $value->id)->pluck('tag_id');
          $tag_name = Tag::whereIn('id', $tagfrompost)->pluck('name');
          $value['tag_id'] = $tag_name;


        }


        return view('tags.show')->with(['tag'=> $tag , 'tag_count' => $tag_count, 'post_data'=>$postdata]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $tag = Tag::find($id);
        return view('tags.edit')->with(['tag' => $tag]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $tag = Tag::find($id);
        $this->validate($request, ['name'=>'required|max:255']);

        $tag->name = $request->name;
        $tag->save();

        Session::flash('success','Successfully saved your new tag');
        return redirect()->route('tags.show', $tag->id);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $tag = Post_Tagging::where('tag_id', $id)->delete();
        $post = Tag::where('id', $id)->delete();
        Session::flash('Success', 'Tag was deleted successfully');
        return redirect()->route('tags.index');
    }
}

resources/views/tags/edit.blade.php
@extends('main')

@section('title', '| Edit Tag')

@section('content')

  {{ Form::model($tag, ['route' => ['tags.update', $tag->id], 'method' => "PUT"]) }}
    {{ Form::label('name','Name:')}}
    {{ Form::text('name', null, ['class'=>'form-control'])}}

    {{ Form::submit('Save Changes', ['class'=> 'btn btn-success', 'style' => 'margin-top:20px'])}}
  {{ Form::close() }}

@endsection

resources/views/tags/index.blade.php
@extends('main')

@section('title', '| All Tags')

@section('content')

  <div class="row">
    <div class="col-md-8">
      <h1>Tags</h1>
      <table class="table">
        <thead>
          <tr>
            <th>#</th>
            <th>Name</th>
          </tr>
        </thead>
        <tbody>
          @foreach ($tags as $tag)
          <tr>
            <th>{{$tag->id}}</th>
            <td><a href="{{ route('tags.show', $tag->id) }}">{{$tag -> name}}</a></td>
          @endforeach
          </tr>
        </tbody>
      </table>
    </div>

    <div class="col-md-3">
      <div class="well">
        {!! Form::open(['route' => 'tags.store', 'method'=>'POST']) !!}
        <h2>New Tag</h2>
        {{ Form::label('name', 'Name: ') }}
        {{ Form::text('name', null, ['class' => 'form-control']) }}
        {{ Form::submit('Create new Tag', ['class'=>'btn btn-primary btn-block btn-h1-spacing']) }}

        </div>

      </div>

    </div>
  </div>

@endsection

resources/views/tags/show.blade.php
@extends('main')

@section('title', "| $tag->name Tag")

@section('content')

<div class="row">
  <div class="col-md-8">
    <h1>{{ $tag-> name }} Tag <small>{{ $tag_count }} posts</small></h1>
  </div>
  <div class="col-md-2">
    <a href=" {{ route('tags.edit', $tag->id) }}" class="btn btn-primary btn-block pull-right" style="margin-top:20px">Edit</a>
  </div>
  <div class="col-md-2">
    {{ Form::open(['route'=>['tags.destroy', $tag->id], 'method'=>'DELETE']) }}
      {{ Form::submit('Delete', ['class'=>'btn btn-danger btn-block', 'style'=>'margin-top:20px']) }}
    {{ Form::close() }}
  </div>
</div>

<div class="row">
  <div class="col-md-12">
    <table class="table">
      <thead>
        <tr>
          <th>#</th>
          <th>Title</th>
          <th>Tags</th>
          <th></th>
        </tr>
      </thead>
      <tbody>
        @foreach($post_data as $post)
        <tr>
          <th>{{ $post->id }}</th>
          <th>{{ $post->title }}</th>
          <td>@foreach($post -> tag_id as $tag)
                <span class="label label-default">{{ $tag }}</span>
              @endforeach
          </td>
          <td><a href=" {{ route('posts.show', $post->id) }}" class="btn btn-default btn-sm">View</a></td>

        </tr>

        @endforeach
      </tbody>
    </table>
  </div>
</div>


@endsection